# debug info seem not works with D compiler
%global debug_package %{nil}

%global major_version 0
%global minor_version 9
%global patch_version 9
#%%global pre beta

Name:           libdparse
Version:        %{major_version}.%{minor_version}.%{patch_version}
Release:        8%{?pre:.%{pre}}%{?dist}
Summary:        Library for lexing and parsing D source code
Summary(fr):    Bibliothèque pour l'analyse syntaxique et grammaticale de code source D
License:        Boost
URL:            https://github.com/dlang-community/libdparse
Source0:        https://github.com/dlang-community/libdparse/archive/v%{version}%{?pre:-%{pre}}/%{name}-%{version}%{?pre:-%{pre}}.tar.gz

ExclusiveArch:  %{ldc_arches}

BuildRequires:  ldc meson stdx-allocator-devel
Requires:       ldc-phobos ldc-druntime stdx-allocator

%description
Library for lexing and parsing D source code.

%description -l fr
Bibliothèque pour l'analyse syntaxique et grammaticale de code source en D.

%package        devel
Summary:        Development files for %{name}
Summary(fr):    Fichiers de développement pour %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:    stdx-allocator-devel

%description devel
libdparse package contains header files for developing D applications
that use libdparse.

%description devel -l fr
Le paquet libdparse contient les fichiers d'entêtes pour développer
des applications en D utilisant libdparse.


%package geany-tags
Summary:        Support for enable autocompletion in geany
Summary(fr):    Support pour activer l'auto-complétion dans geany
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch
BuildRequires:  geany
Requires:       geany

%description geany-tags
Enable autocompletion for dsymbol library in geany (IDE)

%description -l fr geany-tags
Active l'autocompletion pour pour la bibliothèque dsymbol dans geany (IDE)

%prep
%autosetup -p1 -n %{name}-%{version}%{?pre:-%{pre}}
# temp geany config directory for allow geany to generate tags
mkdir geany_config
sed -i '/^\s*version:/  s/0.9.4/0.9.9/' meson.build

%build

export DFLAGS='-w -release -g -O2'
LDFLAGS='-Wl,-z,relro -Wl,-z,now' %meson
#meson_build

# generate doc
src_dir='src'
sources=$(find "${src_dir}" -name '*.d')
for f in ${sources[@]}; do
    d_path=$(dirname ${f});
    d_file=$(basename ${f});
    doc_file=doc-src/${d_path/${src_dir}}/${d_file/.d/.html};
    ldc2 -I %{_includedir}/d/stdx-allocator -I "${src_dir}" -o- -c $f -Df $"{doc_file}" doc-src/index.ddoc doc-src/macros.ddoc;
done
mv doc-src html

# generate geany tags
headers=$(find src -name '*.d')
geany -c geany_config -g %{name}.d.tags ${headers[@]}

%install
%meson_install

# geany tags
mkdir -p %{buildroot}%{_datadir}/geany/tags/
install -pm0644 %{name}.d.tags %{buildroot}/%{_datadir}/geany/tags/

%check
%meson_test

%ldconfig_scriptlets

%files
%license LICENSE_1_0.txt
%doc README.md
%{_libdir}/libdparse.so.%{version}
%{_libdir}/libdparse.so.%{major_version}

%files devel
%doc html
%{_libdir}/pkgconfig/dparse.pc
%{_includedir}/d/dparse
%{_libdir}/libdparse.so

%files geany-tags
%{_datadir}/geany/tags/%{name}.d.tags


%changelog
* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.9-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Tue Apr 16 2019 Adam Williamson <awilliam@redhat.com> - 0.9.9-7
- Rebuild with Meson fix for #1699099

* Tue Apr 09 2019 Kalev Lember <klember@redhat.com> - 0.9.9-6
- Rebuilt for ldc 1.15

* Mon Feb 18 2019 Kalev Lember <klember@redhat.com> - 0.9.9-5
- Rebuilt for ldc 1.14

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.9-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Sun Oct 14 2018 Kalev Lember <klember@redhat.com> - 0.9.9-3
- Rebuilt for ldc 1.12

* Sun Aug 26 2018 MERCIER Jonathan <bioinfornatics at gmail.com> - 0.9.2-2
- Apply  Robert-André Mauchin fix

* Thu Aug  2 2018 MERCIER Jonathan <bioinfornatics at gmail.com> - 0.9.0-1
- Initial release
